# ARST打卡第37周[37/521]

<!--more-->

## Algorithm
中序非递归遍历树 实现 树的中序迭代器
```cpp
/*

TreeNode *root = new TreeNode(1);
root->left = new ... 2
....
// Please implement a class called NodeIterator, so that:
NodeIterator i(root);
i.hasNext(); // true
i.next(); // 4
i.next(); // 2
i.next(); // 1
i.next(); // 5
i.next(); // 3
i.hasNext(); // false
i.next(); // throw
*/
TreeNode {
  int val;
  TreeNode *left;
  TreeNode *right;
}

class NodeIterator {
    public :
        NodeIterator(TreeNode * root){
            if(root == nullptr){
                return ;
            }

            TreeNode * tp = root;

            check();
        }

        // 建议使用着先访问hasNext函数
        bool hasNext(){
            return !s.empty();
        }

        int next(){
            if(!hasNext()) throw exception("No more data.");

            tp = s.top();
            int ans = tp -> val;

            s.pop();

            tp = tp -> right;

            check();

            return ans;
         }

        void check(){
            // 自己不为nullptr放入
            while(tp != nullptr){
                s.push(tp);
                tp = tp -> left;
            }
        }


    private:
        stack<TreeNode*> s;
        TreeNode * tp;
}
```


## Review
[How I Learned to 5x My Income, 10x My Confidence, and Create a Future of Unlimited Possibility](https://medium.com/the-ascent/how-i-learned-to-5x-my-income-10x-my-confidence-and-create-a-future-of-unlimited-possibility-d51620009fc7)

这篇文章一点都不引人入胜，是一片鸡汤文，而且还是标题党水文，不过证明了自己阅读能力上升了一点点，看出了这是一篇大水文

不过有一个观点值得肯定的是 ： **接纳自己，寻找自己的长处，然后为此感到自信，然后勇敢地挑战自己的边界**

## Tips
[张小龙-年薪近3亿的微信之父，他是如何做到的？](https://blog.csdn.net/jxq0816/article/details/103201600)

情怀有时候真的能够当饭吃

~~其实之前自己看过一次类似内容的~~

### linux显示指定行的3种方法
#### 一，从第3000行开始，显示1000行。即显示3000~3999行

`cat filename | tail -n +3000 | head -n 1000`

#### 二，显示1000行到3000行

`cat filename| head -n 3000 | tail -n +1000`

**注意两种方法的顺序**

分解：
```bash
## 显示最后1000行
    tail -n 1000

## 从1000行开始显示，显示1000行以后的
    tail -n +1000

## 显示前面1000行
    head -n 1000
```


#### 三，用sed命令

`sed -n '5,10p' filename`

这样你就可以只查看文件的第5行到第10行


#### 参考自
苏轶然： suanec - http://www.cnblogs.com/suanec/


## Share 看书分享
《Linux命令行与shell脚本编程大全》
在考试周的前一周，也是2020年的第一周，我把这本看了1/4的书定为本周读完计划，然后这一周没有复习，下周挑战5天三门考试的挑战(DSP数字信号处理,高频,单片机)
不过看完这本书是真香，自己对于linux命令行和shell脚本的理解有了一个大的框架，以后什么地方出了问题，我都能找到问题出在哪里了，这样非常有利于我更加熟练的使用linux操作系统，以及linux服务器，也为我后面看APUE(《Unix环境高级编程》)提供更加坚实的基础，为自己以后成为一个更加优秀的IT技术创造美好生活提供了一把瑞士军刀，冲冲冲

听说2020是程序员的本命年？ 2020-1024 = 996 ？ 233，但是**我们不是普通的程序员，我们可以用技术创造更加美好的生活，让世界变得更好，更便捷，更安全，更智能**

推荐你们看这本书

![](https://cdn.jsdelivr.net/gh/wolfdan666/BlogPic/books/linux-shell.jpg)



